#ifndef REP_TIMEMODEL_SOURCE_H
#define REP_TIMEMODEL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtCore>

class PresetInfo
{
    Q_GADGET

    Q_PROPERTY(int presetNumber READ presetNumber WRITE setPresetNumber)
    Q_PROPERTY(float frequency READ frequency WRITE setFrequency)
    Q_PROPERTY(QString stationName READ stationName WRITE setStationName)
public:
    PresetInfo() : m_presetNumber(), m_frequency(), m_stationName() {}
    explicit PresetInfo(int presetNumber, float frequency, QString stationName) : m_presetNumber(presetNumber), m_frequency(frequency), m_stationName(stationName) {}
    int presetNumber() const { return m_presetNumber; }
    void setPresetNumber(int presetNumber) { if (presetNumber != m_presetNumber) { m_presetNumber = presetNumber; } }
    float frequency() const { return m_frequency; }
    void setFrequency(float frequency) { if (frequency != m_frequency) { m_frequency = frequency; } }
    QString stationName() const { return m_stationName; }
    void setStationName(QString stationName) { if (stationName != m_stationName) { m_stationName = stationName; } }
private:
    int m_presetNumber;
    float m_frequency;
    QString m_stationName;
};

inline bool operator==(const PresetInfo &left, const PresetInfo &right) Q_DECL_NOTHROW {
    return left.presetNumber() == right.presetNumber() && left.frequency() == right.frequency() && left.stationName() == right.stationName();
}
inline bool operator!=(const PresetInfo &left, const PresetInfo &right) Q_DECL_NOTHROW {
    return !(left == right);
}

inline QDataStream &operator<<(QDataStream &ds, const PresetInfo &obj) {
    QtRemoteObjects::copyStoredProperties(&obj, ds);
    return ds;
}

inline QDataStream &operator>>(QDataStream &ds, PresetInfo &obj) {
    QtRemoteObjects::copyStoredProperties(ds, &obj);
    return ds;
}


class PresetData
{
    Q_GADGET

    Q_PROPERTY(QList<QString> bla READ bla WRITE setBla)
public:
    PresetData() : m_bla() {}
    explicit PresetData(QList<QString> bla) : m_bla(bla) {}
    QList<QString> bla() const { return m_bla; }
    void setBla(QList<QString> bla) { if (bla != m_bla) { m_bla = bla; } }
private:
    QList<QString> m_bla;
};

inline bool operator==(const PresetData &left, const PresetData &right) Q_DECL_NOTHROW {
    return left.bla() == right.bla();
}
inline bool operator!=(const PresetData &left, const PresetData &right) Q_DECL_NOTHROW {
    return !(left == right);
}

inline QDataStream &operator<<(QDataStream &ds, const PresetData &obj) {
    QtRemoteObjects::copyStoredProperties(&obj, ds);
    return ds;
}

inline QDataStream &operator>>(QDataStream &ds, PresetData &obj) {
    QtRemoteObjects::copyStoredProperties(ds, &obj);
    return ds;
}


class MinuteTimerSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "MinuteTimer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "416fffbfe53b0a0d6e09875ba659c76c9cae17ac")
    Q_PROPERTY(int hour READ hour WRITE setHour NOTIFY hourChanged)
    Q_PROPERTY(int minute READ minute WRITE setMinute NOTIFY minuteChanged)

public:
    explicit MinuteTimerSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QList<QString>>();
        qRegisterMetaTypeStreamOperators<QList<QString>>();
        qRegisterMetaType<PresetData>();
        qRegisterMetaTypeStreamOperators<PresetData>();
        qRegisterMetaType<PresetInfo>();
        qRegisterMetaTypeStreamOperators<PresetInfo>();
        qRegisterMetaType<QMap<QString, QString>>();
        qRegisterMetaTypeStreamOperators<QMap<QString, QString>>();
        qRegisterMetaType<PresetInfo>();
        qRegisterMetaTypeStreamOperators<PresetInfo>();

    }

public:
    ~MinuteTimerSource() override = default;

    virtual int hour() const = 0;
    virtual int minute() const = 0;
    virtual void setHour(int hour) = 0;
    virtual void setMinute(int minute) = 0;

Q_SIGNALS:
    void hourChanged(int hour);
    void minuteChanged(int minute);
    void timeChanged();
    void timeChanged2(const QTime & t);
    void sendCustom(PresetInfo info);
    void foo(QMap<QString, QString> foo);

public Q_SLOTS:
    virtual void pushHour(int hour)
    {
        setHour(hour);
    }
    virtual void pushMinute(int minute)
    {
        setMinute(minute);
    }
    virtual void SetTimeZone(const int & __repc_variable_1) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class MinuteTimerSimpleSource : public MinuteTimerSource
{
    Q_OBJECT

public:
    explicit MinuteTimerSimpleSource(QObject *parent = nullptr) : MinuteTimerSource(parent)
    , m_hour(1)
    , m_minute(51)
    {
    }

public:
    ~MinuteTimerSimpleSource() override = default;

    int hour() const override { return m_hour; }
    int minute() const override { return m_minute; }
    void setHour(int hour) override
    {
        if (hour != m_hour) {
            m_hour = hour;
            Q_EMIT hourChanged(m_hour);
        }
    }
    void setMinute(int minute) override
    {
        if (minute != m_minute) {
            m_minute = minute;
            Q_EMIT minuteChanged(m_minute);
        }
    }

private:
    int m_hour;
    int m_minute;
};


template <class ObjectType>
struct MinuteTimerSourceAPI : public SourceApiMap
{
    MinuteTimerSourceAPI(ObjectType *object, const QString &name = QLatin1String("MinuteTimer"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::hour, static_cast<int (QObject::*)()>(0),"hour");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::hourChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::minute, static_cast<int (QObject::*)()>(0),"minute");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::minuteChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 6;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::hourChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::minuteChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::timeChanged, static_cast<void (QObject::*)()>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::timeChanged2, static_cast<void (QObject::*)(QTime)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::sendCustom, static_cast<void (QObject::*)(PresetInfo)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::foo, static_cast<void (QObject::*)(QMap<QString,QString>)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_methods[0] = 3;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushHour, static_cast<void (QObject::*)(int)>(0),"pushHour(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMinute, static_cast<void (QObject::*)(int)>(0),"pushMinute(int)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::SetTimeZone, static_cast<void (QObject::*)(int)>(0),"SetTimeZone(int)",m_methodArgCount+2,&m_methodArgTypes[2]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("MinuteTimer"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("hourChanged(int)");
        case 1: return QByteArrayLiteral("minuteChanged(int)");
        case 2: return QByteArrayLiteral("timeChanged()");
        case 3: return QByteArrayLiteral("timeChanged2(QTime)");
        case 4: return QByteArrayLiteral("sendCustom(PresetInfo)");
        case 5: return QByteArrayLiteral("foo(QMap<QString,QString>)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushHour(int)");
        case 1: return QByteArrayLiteral("pushMinute(int)");
        case 2: return QByteArrayLiteral("SetTimeZone(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"416fffbfe53b0a0d6e09875ba659c76c9cae17ac"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[7];
    int m_methods[4];
    const QString m_name;
    int m_signalArgCount[6];
    const int* m_signalArgTypes[6];
    int m_methodArgCount[3];
    const int* m_methodArgTypes[3];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_TIMEMODEL_SOURCE_H
